# (c) Copyright 2014, Synapse Wireless, Inc.
# BTLE Constants
#  References: bluez/lib/uuid.h 
#              bluez/attrib/att.h
ATT_OP_ERROR                    = 0x01
ATT_OP_MTU_REQ                  = 0x02
ATT_OP_MTU_RESP                 = 0x03
ATT_OP_FIND_INFO_REQ            = 0x04
ATT_OP_FIND_INFO_RESP           = 0x05
ATT_OP_FIND_BY_TYPE_REQ         = 0x06
ATT_OP_FIND_BY_TYPE_RESP        = 0x07
ATT_OP_READ_BY_TYPE_REQ         = 0x08
ATT_OP_READ_BY_TYPE_RESP        = 0x09
ATT_OP_READ_REQ                 = 0x0a
ATT_OP_READ_RESP                = 0x0b
ATT_OP_READ_BLOB_REQ            = 0x0c
ATT_OP_READ_BLOB_RESP           = 0x0d
ATT_OP_READ_MULTI_REQ           = 0x0e
ATT_OP_READ_MULTI_RESP          = 0x0f
ATT_OP_READ_BY_GROUP_REQ        = 0x10
ATT_OP_READ_BY_GROUP_RESP       = 0x11
ATT_OP_WRITE_REQ                = 0x12
ATT_OP_WRITE_RESP               = 0x13
ATT_OP_WRITE_CMD                = 0x52
ATT_OP_PREP_WRITE_REQ           = 0x16
ATT_OP_PREP_WRITE_RESP          = 0x17
ATT_OP_EXEC_WRITE_REQ           = 0x18
ATT_OP_EXEC_WRITE_RESP          = 0x19
ATT_OP_HANDLE_NOTIFY            = 0x1b
ATT_OP_HANDLE_IND               = 0x1d
ATT_OP_HANDLE_CNF               = 0x1e
ATT_OP_SIGNED_WRITE_CMD         = 0xd2

GATT_PRIM_SVC_UUID              = 0x2800
GATT_INCLUDE_UUID               = 0x2802
GATT_CHARAC_UUID                = 0x2803

GATT_CLIENT_CHARAC_CFG_UUID     = 0x2902
GATT_SERVER_CHARAC_CFG_UUID     = 0x2903

ATT_ECODE_SUCCESS               = 0x00
ATT_ECODE_INVALID_HANDLE        = 0x01
ATT_ECODE_READ_NOT_PERM         = 0x02
ATT_ECODE_WRITE_NOT_PERM        = 0x03
ATT_ECODE_INVALID_PDU           = 0x04
ATT_ECODE_AUTHENTICATION        = 0x05
ATT_ECODE_REQ_NOT_SUPP          = 0x06
ATT_ECODE_INVALID_OFFSET        = 0x07
ATT_ECODE_AUTHORIZATION         = 0x08
ATT_ECODE_PREP_QUEUE_FULL       = 0x09
ATT_ECODE_ATTR_NOT_FOUND        = 0x0a
ATT_ECODE_ATTR_NOT_LONG         = 0x0b
ATT_ECODE_INSUFF_ENCR_KEY_SIZE  = 0x0c
ATT_ECODE_INVAL_ATTR_VALUE_LEN  = 0x0d
ATT_ECODE_UNLIKELY              = 0x0e
ATT_ECODE_INSUFF_ENC            = 0x0f
ATT_ECODE_UNSUPP_GRP_TYPE       = 0x10
ATT_ECODE_INSUFF_RESOURCES      = 0x11

# Characteristic enumerations
RESULT_SUCCESS                  = 0x00
RESULT_INVALID_OFFSET           = 0x07
RESULT_ATTR_NOT_LONG            = 0x0b
RESULT_INVALID_ATTRIBUTE_LENGTH = 0x0d
RESULT_UNLIKELY_ERROR           = 0x0e

# BTLE Properties for characteristics/descriptors
BTLE_NONE              = 0x00
BTLE_READ              = 0x02
BTLE_WRITE             = 0x08
BTLE_WRITE_WO_RESPONSE = 0x04
BTLE_NOTIFY            = 0x10

# BTLE Security Values
BTLE_SECURITY_LOW      = 0x01
BTLE_SECURITY_MEDIUM   = 0x02
BTLE_SECURITY_HIGH     = 0x03

# MTU
DEFAULT_MTU = 23