import sys
import socket
import urllib2
import pprint
import datetime
import traceback
import ssl


class ConnectRequest(urllib2.Request):
    def get_method(self):
        return "CONNECT"

    def get_selector(self):
        return "/"


def authorize(sock, data):
    options = urllib2.parse_keqv_list(urllib2.parse_http_list(data[data.find("Digest")+7:]))
    if (options.has_key("nonce") and 
        options.has_key("qop") and 
        options.get('qop', "") == "auth"):

        class Passwd(urllib2.HTTPPasswordMgr):
            def find_user_password(self, realm, authuri):
                return ("public", "public")
        pass_mgr = Passwd()
        #pass_mgr.auth_info = self.auth_info

        digest_handler = urllib2.AbstractDigestAuthHandler(pass_mgr)
        auth = digest_handler.get_authorization(ConnectRequest(""), options)
        sock.send("Authorization: Digest %s\r\n" % (auth))
        print "Sent authorization:"
        try:
            new_data = sock.recv(8192)
            print "Received %i bytes of data:" % (len(new_data))
            pprint.pprint(new_data)
            if "200" in new_data:
                print "Authenticated connection established"
            else:
                print "Unable to create connection"
        except:
            print traceback.print_exc()
    else:
        print "Received unexpected response from server, did not try to authorize"  


WEB_ADDR = 'www.snaplighting.com'
KIT_ADDR = 'kit-test.kits.snaplighting.com'

GET_REQUEST_10 = "GET /index.html HTTP/1.0\r\nHost: %s\r\n\r\n"  % (KIT_ADDR)
GET_REQUEST_11 = "GET /index.html HTTP/1.1\r\nHost: %s\r\n\r\n"  % (KIT_ADDR)
CONNECT_REQUEST_10 = "CONNECT localhost:48625 HTTP/1.0\r\nHost: %s\r\n\r\n" % (KIT_ADDR)
CONNECT_REQUEST_11 = "CONNECT localhost:48625 HTTP/1.1\r\nHost: %s\r\n\r\n" % (KIT_ADDR)
CONNECT_REQUEST_11_2 = "CONNECT localhost:48625 HTTP/1.1\r\nHost: %s:80\r\n\r\n" % (KIT_ADDR)


print datetime.datetime.now()
print sys.version
print ssl.OPENSSL_VERSION

print "Checking DNS record for %s:" % (WEB_ADDR),
try:
    ip = socket.gethostbyname(WEB_ADDR)
    print ip
except socket.gaierror:
    print "Unable to resolve DNS"
    sys.exit()

print "Trying to retrieve web page from %s:" % (WEB_ADDR),
try:
    result = urllib2.urlopen('https://%s/' % (WEB_ADDR))
except urllib2.URLError:
    print "Unable to retrieve page"
else:
    print result.msg

print "Checking DNS record for %s:" % (KIT_ADDR), 
try:
    ip = socket.gethostbyname(KIT_ADDR)
    print ip
except socket.gaierror:
    print "Unable to resolve DNS"
    sys.exit()

# HTTP/1.0
print "Trying to connect to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((KIT_ADDR, 80)) # Throws exception if it doesn't connect
print "My address info: ", s.getsockname()
print "CONNECTED!!! Sending:\n%s" % (GET_REQUEST_10)
send_len1 = s.send(GET_REQUEST_10)
print "Sent %i bytes out of %i" % (send_len1, len(GET_REQUEST_10))
try:
    data = s.recv(8192)
    print "Received %i bytes of data" % (len(data))
    pprint.pprint(data)
    s.close()
except:
    print traceback.print_exc()

print "Trying to connect to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((KIT_ADDR, 80)) # Throws exception if it doesn't connect
print "CONNECTED!!! Sending:\n%s" % (CONNECT_REQUEST_10)
send_len2 = s.send(CONNECT_REQUEST_10)
print "Sent %i bytes out of %i" % (send_len2, len(CONNECT_REQUEST_10))
try:
    data = s.recv(8192)
    print "Received %i bytes of data:" % (len(data))
    pprint.pprint(data)

    authorize(s, data)
    s.close()
except:
    print traceback.print_exc()

print ""


print "Trying SSL connection to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
ssl_sock = ssl.wrap_socket(s)
try:
    ssl_sock.connect((KIT_ADDR, 443)) # Throws exception if it doesn't connect
except ssl.SSLError:
    print traceback.print_exc()
else:
    print "My address info: ", ssl_sock.getsockname()
    print "CONNECTED!!! Sending:\n%s" % (GET_REQUEST_10)
    send_len1 = ssl_sock.send(GET_REQUEST_10)
    print "Sent %i bytes out of %i" % (send_len1, len(GET_REQUEST_10))
    try:
        data = ssl_sock.recv(8192)
        print "Received %i bytes of data" % (len(data))
        pprint.pprint(data)
        ssl_sock.close()
    except:
        print traceback.print_exc()

print "Trying SSL connection to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
ssl_sock = ssl.wrap_socket(s, ssl_version=ssl.PROTOCOL_SSLv3)
try:
    ssl_sock.connect((KIT_ADDR, 443)) # Throws exception if it doesn't connect
except ssl.SSLError:
    print traceback.print_exc()
else:
    print "CONNECTED!!!"
    print pprint.pformat(ssl_sock.getpeercert())
    print "Sending:\n%s" % (CONNECT_REQUEST_10)
    send_len2 = ssl_sock.send(CONNECT_REQUEST_10)
    print "Sent %i bytes out of %i" % (send_len2, len(CONNECT_REQUEST_10))
    try:
        data = ssl_sock.recv(8192)
        print "Received %i bytes of data:" % (len(data))
        pprint.pprint(data)
    
        authorize(ssl_sock, data)
        ssl_sock.close()
    except:
        print traceback.print_exc()


print ""


# HTTP/1.1
print "Trying to connect to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((KIT_ADDR, 80)) # Throws exception if it doesn't connect
print "CONNECTED!!! Sending:\n%s" % (GET_REQUEST_11)
send_len1 = s.send(GET_REQUEST_10)
print "Sent %i bytes out of %i" % (send_len1, len(GET_REQUEST_11))
try:
    data = s.recv(8192)
    print "Received %i bytes of data" % (len(data))
    pprint.pprint(data)
    s.close()
except:
    print traceback.print_exc()

print "Trying to connect to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((KIT_ADDR, 80)) # Throws exception if it doesn't connect
print "CONNECTED!!! Sending:\n%s" % (CONNECT_REQUEST_11)
send_len2 = s.send(CONNECT_REQUEST_11)
print "Sent %i bytes out of %i" % (send_len2, len(CONNECT_REQUEST_11))
try:
    data = s.recv(8192)
    print "Received %i bytes of data:" % (len(data))
    pprint.pprint(data)

    authorize(s, data)
    s.close()
except:
    print traceback.print_exc()

print "Trying to connect to %s:" % (KIT_ADDR)
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((KIT_ADDR, 80)) # Throws exception if it doesn't connect
print "CONNECTED!!! Sending:\n%s" % (CONNECT_REQUEST_11_2)
send_len2 = s.send(CONNECT_REQUEST_11_2)
print "Sent %i bytes out of %i" % (send_len2, len(CONNECT_REQUEST_11_2))
try:
    data = s.recv(8192)
    print "Received %i bytes of data:" % (len(data))
    pprint.pprint(data)

    authorize(s, data)
    s.close()
except:
    print traceback.print_exc()
