# (c) Copyright 2009, Synapse Wireless, Inc.
''' The job of this class is to format (snaplayout) a memory image of the passed in file
    that matches the needs of the MC1322x "Boot Helper".'''
__docformat__ = "plaintext en"

import HuffmanPacker as hp

class MC1322xLayout(object):
    def __init__(self, contents):
        self.image = contents
        self.uncompressed = hp.EncodeSRec(contents)
        self.compressed = None

    def getContents(self, space_avail):
        if len(self.uncompressed) > space_avail:
            if self.compressed is None:
                self.compressed = hp.CompressSRec(self.image)
                assert(space_avail >= len(self.compressed))
            return self.compressed
        else:
            return self.uncompressed

