# (c) Copyright 2012 Synapse Wireless, Inc.
#
# The job of this class is to format (snaplayout) a memory image of the passed in SRecord file
# that matches the needs of the STM32W108xB "Boot Helper".
#
# This was originally a much larger class, but the common functionality was factored out
# into a new class, CoreLayout, which this class now customizes.
#

import CoreLayout
import pys19 # pys19.S19 will be our "CoreReader"

class STM32W108xB_Layout(CoreLayout.CoreLayout):
    CORE_START_ADDRESS = 0x00400
    CORE_END_ADDRESS   = 0x0F7FF # <- NV Parameter area #1 starts at 0000_F800H
    
    def __init__(self, contents):
        super(STM32W108xB_Layout, self).__init__(
            pys19.S19(byteBoundary=256),
            contents,
            ((self.CORE_START_ADDRESS, self.CORE_END_ADDRESS),) # <- Important! Keep that last comma!!!
        )

    # for the rest of the story, see CoreLayout.py
