# (c) Copyright 2008 Synapse wireless, Inc.
"""
Minimal Mesh Routing - Implements just enough Mesh Routing support to allow Portal to be "discovered" by the SNAP Nodes
"""


import MeshCodec
from SnapConstants import *


def processMeshPacket(pkt, myAddresses):
    """Handle incoming Mesh Routing packets"""
    descriptor = MeshCodec.MeshCodec.decode(pkt)
    # for now, the only one we care about is RREQ (Route Request)
    if descriptor and descriptor.msgId == MESH_RREQ:
        # If we (Portal) are the node being searched for, answer with a RREP (Route Reply)
        if descriptor.target in myAddresses:
            # DYMO rules of sequence number updating require us to look at the incoming request
            MeshCodec.MeshCodec.adjustSequenceNumber(descriptor)
            # Build the description of a reply
            reply = MeshCodec.MeshCodec.build_rrep(descriptor)
            ## Build the actual packet from the description
            #replyPacket = MeshCodec.MeshCodec.encode(reply)
            #return replyPacket
            return reply
