# (c) Copyright 2009 Synapse Wireless, Inc.
"""
Trace Route handling - special packets that reveal the current paths to specific SNAP nodes
"""

import TraceRouteCodec
from SnapConstants import *
from PacketQueue import *

class TraceRouteHandler(object):
    def __init__(self, packetQueue):
        packetQueue.registerCallback('TraceRoute', self.processTraceRoutePacket)

    def processTraceRoutePacket(self, pkt):
        """Handle incoming Trace Route packets"""
        traceRouteDesc = TraceRouteCodec.decode(pkt)
        # prove all the data was captured. Mark will put it up onto the GUI somehow
        for record in traceRouteDesc.records:
            print 'address=' + record.address + 'LQ='+ str(record.linkQuality)
    
