"Include this generated file after function definitions"


import BuiltIn
import os
import sys

BANDAID_LIST = ["rpc", "mcastRpc", "saveNvParam", "resetVm", "eraseImage",
    "writeChunk", "initVm", "rpcSourceAddr", "stdinMode", "chr", "cbusRd",
    "i2cRead", "spiRead", "spiXfer", "str", "vmStat", "updateDmxBuf"]

CBUS_LIST = ["cbusRd", "cbusWr"]
I2C_LIST = ["i2cInit", "i2cWrite", "i2cRead", "getI2cResult" ]
SPI_LIST = ["spiInit", "spiWrite", "spiRead", "spiXfer"]
DMX_LIST = ["updateDmxBuf", "getDmxBuf"]

def decorate(name):
    "Apply C-code 'pyWrapper' naming convention"
    return 'py' + name[0].upper() + name[1:]


if __name__ == "__main__":
    funcName = 'callPyFuncWrap'
    if len(sys.argv) > 1:
      os.chdir(os.path.realpath(sys.argv[1]))

    cf = BuiltIn.__cfuncs__.items()
    cf.sort(key=lambda x: x[1])
    fp = open('pyCFuncTbl.c', 'wb')
    buf = '// Generated by SnappyGen\r\n#include "Knobs.h"\r\n\r\n'
    for nm,info in cf:
        bandaid = " BANDAID" if nm in BANDAID_LIST else ""
        buf += "extern void %s(unsigned char nArgs)%s;\r\n" % (decorate(nm), bandaid)
    buf += ("void %s(U8 funcNum, unsigned char nArgs) BANDAID\r\n{\r\n" +
        "switch (funcNum)\r\n  {\r\n") % funcName
    for nm, info in cf:
        if nm in CBUS_LIST:
          buf += "#if (WITH_CBUS == 1)\r\n"
        if nm in I2C_LIST:
          buf += "#if (WITH_I2C == 1)\r\n"
        if nm in SPI_LIST:
          buf += "#if (WITH_SPI == 1)\r\n"
        if nm in DMX_LIST:
          buf += "#ifdef WITH_DMX\r\n"
        buf += "    case %i:\r\n      %s(nArgs);\r\n      break;\r\n" % \
          (info,decorate(nm))
        if nm == "vmStat":
            vmStatId = info
        if nm in CBUS_LIST + I2C_LIST + SPI_LIST + DMX_LIST:
          buf += "#endif\r\n"
    buf += "  }\r\n}\r\n#define VM_STAT_ID   %d\r\n" % vmStatId
    fp.write(buf)
    fp.close()
