# (c) Copyright 2007-2010, Synapse Wireless, Inc.
"""Hook constants defined for SNAP and the SNAPpy virtual machine"""

# These allow C-code to hook SNAPpy methods to "standard events"
HOOK_STARTUP         = 0    # 0 params
HOOK_GPIN            = 1    # 2 params (pinNum, isSet)
HOOK_100MS           = 2    # 1 param (currentMs)
HOOK_STDIN           = 3    # 1 param (string of received data)
HOOK_STDOUT          = 4    # 0 params
HOOK_RPC_SENT        = 5    # 2 params (identifier, reserved)
HOOK_10MS            = 6    # 1 param (currentMs)
HOOK_1MS             = 7    # 1 param (currentMs)
HOOK_1S              = 8    # 1 param (currentMs)
HOOK_SNAPCOM_OPENED  = 9    # 2 params (tuple (ip,port), nodeAddr)
HOOK_SNAPCOM_CLOSED  = 10   # 2 params (tuple (ip,port), nodeAddr)
HOOK_TRACEROUTE      = 11   # 3 params (nodeAddr, roundTripTime, hops)
HOOK_SERIAL_CLOSE    = 12   # 2 params (serial_type, port)
HOOK_SERIAL_OPEN     = 13   # 3 params (serial_type, port, nodeAddr)

# Mark end of standard hooks
HOOK_LAST            = 14
