"""System Info IDs - used in 'getInfo()' and 'getStat()' calls"""

# Types
SI_TYPE_VENDOR           = 0
SI_TYPE_RADIO            = 1
SI_TYPE_CPU              = 2
SI_TYPE_PLATFORM         = 3
SI_TYPE_BUILD            = 4
SI_TYPE_VERSION_MAJOR    = 5
SI_TYPE_VERSION_MINOR    = 6
SI_TYPE_VERSION_BUILD    = 7
SI_ENCRYPTION_INFO       = 8
SI_RPC_PACKET_SENT_ID    = 9
SI_RPC_IS_MULTICAST_ID   = 10
SI_MULTI_PKT_TTL_ID      = 11
SI_SMALL_STRS_REMAINING  = 12
SI_MEDIUM_STRS_REMAINING = 13
SI_ROUTE_TABLE_SIZE      = 14
SI_ROUTES_IN_TABLE       = 15

# Vendors
SI_VENDOR_SYNAPSE      = 0
SI_VENDOR_FREESCALE    = 2 # value = 1 skipped
SI_VENDOR_CEL          = 3
SI_VENDOR_ATMEL        = 4
SI_VENDOR_SILICON_LABS = 5

# Radios
SI_RADIO_802_15_4 = 0
SI_RADIO_NONE     = 1
SI_RADIO_900      = 2

# CPUs
SI_CPU_MC9S08GT60A = 0
SI_CPU_8051        = 1
SI_CPU_MC9S08QE    = 2
SI_CPU_COLDFIRE    = 3
SI_CPU_ARM7        = 4
SI_CPU_ATMEGA      = 5
SI_CPU_ATMEGA128RFA1      = 5
SI_CPU_SI1000      = 6
SI_CPU_SI1000      = 6
SI_CPU_X86 = 7
SI_CPU_UNKNOWN = 8
SI_CPU_SPARC_LEON = 9
SI_CPU_ARM_CORTEX_M3 = 10
SI_CPU_ATMEGA128RFR2 =  12
SI_CPU_ATMEGA1284RFR2 = 13


# Platforms
SI_PLATFORM_RF_ENGINE           = 0
SI_PLATFORM_CEL_ZIC2410         = 3 # values [1, 2, 4] skipped
SI_PLATFORM_MC1321X             = 5
SI_PLATFORM_ATMEGA128RFA1       = 6
SI_PLATFORM_SNAPCOM             = 7
SI_PLATFORM_SI1000              = 8
SI_PLATFORM_MC1322X             = 9
SI100X_FHSS                     = 11 # value [10, 12] skipped
SI_PLATFORM_SI100X_KADEX        = 11
SI_PLATFORM_RF300               = 13
SI_PLATFORM_RF200_PFM           = 14
SI_PLATFORM_SM300               = 15
SI_PLATFORM_SM301               = 16
SI_PLATFORM_SM200_PFM           = 17
SI_PLATFORM_RN_G2C547           = 18
SI_PLATFORM_RF266_PFM           = 19
SI_PLATFORM_STM32W108xB         = 20
SI_PLATFORM_SM222_PFM           = 25  # value [21, 22, 23, 24] skipped
SI_PLATFORM_ATmega128RFR2_PFM   = 26
SI_PLATFORM_SM220UF1_PFM        = 27
SI_PLATFORM_ATmega1284RFR2_PFM  = 28

# Builds
SI_BUILD_DEBUG   = 0
SI_BUILD_RELEASE = 1

# Encryptions
SI_NO_ENCRYPTION     = 0
SI_AES128_ENCRYPTION = 1
SI_SNAP_ENCRYPTION   = 2

# getStat() Enumerations
STAT_DS_NULL_TX_BUFFERS               = 0
STAT_DS_UART0_RX_BUFFERS              = 1
STAT_DS_UART0_TX_BUFFERS              = 2
STAT_DS_UART1_RX_BUFFERS              = 3
STAT_DS_UART_TX_BUFFERS               = 4
STAT_DS_TRANSPARENT_RX_BUFFERS        = 5
STAT_DS_TRANSPARENT_TX_BUFFERS        = 6
STAT_DS_PACKET_SERIAL_RX_BUFFERS      = 7
STAT_DS_PACKET_SERIAL_TX_BUFFERS      = 8
STAT_DS_RADIO_RX_BUFFERS              = 9
STAT_DS_RADIO_TX_BUFFERS              = 10
STAT_RADIO_FORWARDED_UNICASTS         = 11
STAT_PACKET_SERIAL_FORWARDED_UNICASTS = 12
STAT_RADIO_FORWARDED_XCASTS           = 13
STAT_PACKET_SERIAL_FORWARDED_XCASTS   = 14
STAT_PACKET_SERIAL_RETRIES            = 15 # Debug Builds Only
STAT_PACKET_SERIAL_FAILURES           = 16 # Debug Builds Only
STAT_PACKET_SERIAL_RX_ERRORS          = 17 # Debug Builds Only
STAT_PACKET_SERIAL_RX_BAD_CKSUM       = 18 # Debug Builds Only
STAT_PACKET_SERIAL_NUM_RX_ACKS        = 19 # Debug Builds Only
STAT_PACKET_SERIAL_NUM_RX_DUPS        = 20 # Debug Builds Only
STAT_PACKET_SERIAL_NO_ROOMS           = 21 # Debug Builds Only
